/*
 * COMMON_FUNCTIONS.HPP
 *
 *  Author: Dominique Bouthinon (LIPN, Universite Paris 13)
 */

#ifndef _COMMON_FUNCTIONS_HPP_
#define _COMMON_FUNCTIONS_HPP_

#include <vector>

#include "types_graph.hpp"
#include "graph.hpp"

using namespace std ;


graph<string>* create_initial_graph(
							  string graph_name,
							  bool label_noeuds,
							  vector<string>& objects_names,
							  vector<string>& description_noeuds,
							  Tadjacences_map& adjacences,
							  Tweighted_edges_map& edges_map,
							  bool graphe_oriente,
							  bool graphe_pondere,
							  abstraction& a1,
							  abstraction& a2
					     	) ;


	// affichage des adjacences
void afficher_adjacences(Tadjacences_map&  adjacences) ;

void detect_out_in(vector<string>& objects_names,
				   set<Tvertice_identifier>& VO,
				   set<Tvertice_identifier>& VI,
				   map<string, Tvertice_identifier>& vertice_idents) ;


#endif
