/*
 * type_abstraction.hpp
 *
 *  Created on: 4 mai 2016
 *      Author: dominique
 */

#ifndef _ABSTRACTION_HPP_
#define _ABSTRACTION_HPP_

#include <utility>
using namespace std ;
									// structure pour definir les abstractions
									// appliquées sur un graphe
class abstraction
{
	private :
									// VARIABLES D'INSTANCES
		bool				role ;				// au moins 2 roles
		int             	k_dense ;
		float  				degree  ;
		float				degree_in ;
		float				degree_out ;
		float             	degre_simple ;
		int  				connected_components ;
		bool 				triangles ;
		pair<float, float>  classic_hub_autority ;
		pair<float, float>  hub_autority ;
		pair<float, float>  near_star ;
		pair<float, float>  near_star_in ;
		pair<float, float>  near_star_out ;
		float				abstraction_topologique ;


	public :
									// CONSTRUCTEURS
		abstraction() ;
		abstraction(int k_dense, float degree, float degree_in, float degree_out,
				  	float degre_simple, int connected_components,
					bool triangles,  pair<float, float> classic_hub__autority,
					pair<float, float> hub__autority,
					pair<float, float> near_star,
					pair<float, float> near_star_in, pair<float, float> near_star_out,
					float abstraction_topologique, bool role) ;

									// GETTERS
		int get_k_dense() ;
		float get_degree()  ;
		float get_degree_in() ;
		float get_degree_out() ;
		float get_degre_simple() ;
		int get_connected_components() ;
		bool get_triangles() ;
		pair<float, float> get_classic_hub_autority() ;
		pair<float, float> get_hub_autority() ;
		pair<float, float> get_near_star() ;
		pair<float, float> get_near_star_in() ;
		pair<float, float> get_near_star_out() ;
		float get_abstraction_topologique() ;
		bool get_role() ;

									// SETTERS
		void set_k_dense(int v) ;
		void set_degree(float v)  ;
		void set_degree_in(float v) ;
		void set_degree_out(float v) ;
		void set_degre_simple(float v) ;
		void set_connected_components(int v) ;
		void set_triangles(bool v) ;
		void set_classic_hub_autority_first(float v) ;
		void set_classic_hub_autority_second(float v) ;
		void set_hub_autority_first(float v) ;
		void set_hub_autority_second(float v) ;
		void set_near_star_first(float v) ;
		void set_near_star_second(float v) ;
		void set_near_star_in_first(float v) ;
		void set_near_star_in_second(float v) ;
		void set_near_star_out_first(float v) ;
		void set_near_star_out_second(float v) ;
		void set_abstraction_topologique(float v) ; 
		void set_role(bool role) ;
} ;

#endif /* _ABSTRACTION_HPP_ */
