/**
 * @file   paraminer.hpp
 * @author Benjamin Negrevergne <benjamin@neb.dyn.cs.kuleuven.be>
 * @date   Fri Sep  3 14:44:21 2010
 * 
 * @brief  ParaMiner main file. 
 *
 * (deeply) modified by Dominique Bouthinon (db@lipn.univ-paris13.fr)
 * 
 */

#ifndef   	_PARAMINER_HPP_
#define   	_PARAMINER_HPP_

#include "database.hpp"
#include "graph.hpp"
#include "pattern.hpp"
#include "statsModularity.hpp"

extern TransactionTable &tt; 
extern Tot& ot;

int abstract_local_itemsets(
		                    string data_file,
							bool save_graphs,
							statsModularity& statsMod,
							bool modularity_on,
							float modularity,
							bool support_demande,
							abstraction& a1,
							abstraction& a2,
							bool a2_active,
							bool communauty_abstraction,
							int min_sup,
							bool local,
							bool build_triangles_graph,
							bool build_edges_graph,
							int k_communauty,
							int k_crown,
							graph<string>* g,
							bool graphe_oriente,
							const vector<string>& objects_names,
							const vector<string>& items_names,
							const set_t& permutations,
							int& nb_closed_patterns,
							int& nb_rejected_closed_patterns
			    			);

#endif	    /* _PARAMINER_HPP_ */
