/*
 * display_data.cpp
 *
 *  Created on: 18 mars 2015
 *      Author: dominique
 */


#include <cstdlib>   
#include <fstream>

#include <algorithm>
#include "database.hpp"
#include "display_data.hpp"
#include "utils.hpp"
#include "utils_divers.hpp"


using namespace std ;


void display_object_name(
						 const int object,
                         const vector<string>& objects_names
						)
{
	cout << "\"" << objects_names.at(object) << "\"";
}

		// pas de role
void display_extension_abstraite(
								 const Tvertice_identifiers_set& objects,
								 const vector<string>& objects_names
						  	  	)
{
	cout << "{\"no_role\"->" ;
	display_objects_names(objects, objects_names) ;
	cout << "}" ;
}


		// au moins 2 roles
void display_extension_abstraite(
								 const Troles_set& roles,
								 const vector<string>& objects_names
						  	    )
{
	cout << "{" ;

	Troles_set::const_iterator it_end = roles.end();

	Troles_set::const_iterator it = roles.begin() ;
	cout << "\"" << it->first << "\"->";
    display_objects_names(it->second, objects_names) ;
    it++ ;
	  	  	  	  	  	  	  	 // pour chaque role
    for(; it != it_end; it++)
	{
    	cout << ", " ;
    	// cout << "*it = " << *it << endl ;

    	cout << "\"" << it->first << "\"->";
    	display_objects_names(it->second, objects_names) ;
	}

	cout << "}" ;
}



/**
 *   affiche chaque transaction designes par list_objects
 *   (les noms des objets initiaux de chaque transaction sont affiches)
 */
void display_objects_names(
							const set<int>& objects,
							const vector<string>& objects_names)
{
	// displayVector("initial_objects", initial_objects) ;
	// displayVector("objects_names", initial_objects_names) ;

	cout << "{" ;

	if (!objects.empty())
	{
		set<int>::const_iterator it = objects.begin() ;

		cout << "\"" << objects_names.at(*it) << "\"";
		++it ;

		for ( ; it != objects.end() ; ++it)
		{
			cout << ", \"" << objects_names.at(*it) << "\"";
		}
	}

	cout << "}" ;
}



/**
 *   affiche chaque transaction designes par list_objects
 *   (les noms des objets initiaux de chaque transaction sont affiches)
 */
void display_objects_names(
							const vector<int>& objects,
							const vector<string>& objects_names)
{
	// displayVector("initial_objects", initial_objects) ;
	// displayVector("objects_names", initial_objects_names) ;

	cout << "{" ;

	if (!objects.empty())
	{
		vector<int>::const_iterator it = objects.begin() ;

		cout << "\"" << objects_names.at(*it) << "\"";
		++it ;

		for ( ; it != objects.end() ; ++it)
		{
			cout << ", \"" << objects_names.at(*it) << "\"";
		}
	}

	cout << "}" ;
}



void outputPattern(
				   bool show_tids,
				   TransactionTable& tt,
				   const Toccurences& occs,
				   set_t pattern,
				   int set_support
				  )
{
					  // output lclosed pattern
		#ifdef TRACK_TIDS
						// Get original tids
		set_t orig_tids;
		if (show_tids)
		{
			orig_tids.reserve(occs.size());

			Toccurences::iterator it ;

			for(it = occs.begin() ; it != occs.end(); it++)
			{
				orig_tids.insert(orig_tids.end(), tt[*it].tids.begin(),
											  tt[*it].tids.end());
			}
			sort(orig_tids.begin(), orig_tids.end());
		}

		pattern_print(pattern, set_support, orig_tids);

		#else
		set_t *orig_tids; //dummy set, won't be read
		pattern_print(closed_pattern, set_support, *orig_tids);

		#endif //TRACK_TIDS
}



void outputOriginalPatternCerr(
							set_t pattern,
							const vector<string>& items_names
				          )
{
		original_pattern_print_cerr(pattern, items_names);
}


void outputOriginalPattern(
							set_t pattern,
							const vector<string>& items_names
				          )
{
		original_pattern_print(pattern, items_names);
}


void outputOriginalPattern2(
							set_t pattern,
							const vector<string>& items_names,
							const set_t& permutations
				          )
{
		original_pattern_print2(pattern, items_names, permutations);
}



void outputLocalPattern(
						 set_t closed_pattern_cci,
						 const vector<string>& items_names
						)
{
			  	  // output local closed pattern

		original_pattern_print(closed_pattern_cci, items_names);
}




