/**
 */
#ifndef UTILS_DIVERS_
#define UTILS_DIVERS_
 
#include <string>
#include <vector>
#include <assert.h>
#include <set>
#include <map>
#include <functional>
#include <iostream>
#include <unordered_set>

using namespace std;


	// retourne true si v1 inclut v2, sinon false
template <typename T>
bool inclut(vector<T> v1, vector<T> v2)		// !!! VOLONTAIREMENT COPIES DES ARGUMENTS !!!
											// A CAUSE DU SORT
{
	sort(v1.begin(), v1.end()) ;
	sort(v2.begin(), v2.end()) ;

	return(includes(v1.begin(), v1.end(), v2.begin(), v2.end())) ;
}


/*
 *	  get the strings inside s (strings are separated by delimiter)
 */
void get_strings(const string s, char delimiter, vector<string>& v) ;



/*
 *	  get the ints inside s (ints are separated by delimiter)
 */
void get_ints(const string s, char delimiter, vector<int>& v) ;


/*
 *	  get the ints inside s (ints are separated by delimiter)
 *	  put the values in a set
 */
void get_ints(const string s, char delimiter, set<int>& v) ;


/*
 *	  get the strings inside s (strings are separated by delimiter)
 *	  put the strings in a set
 */
void get_strings(const string s, char delimiter, set<string>& v) ;



void extrait_motif(string& line, int debut, string& motif, int& fin) ;

	// extrait les motifs presents dans une liste de motifs
	// {motif1{...}, motif2{...}, ...}
void extrait_motifs(string& line, int debut, vector<string>& motifs, int& fin) ;


		// display n tabulations
void display_spaces(int n) ;


/**
 * remove all occurences of c in str
 */
void removeChar(string str, char c) ;


/**
 *  delete the spaces in each string inside v
 */
void trimStringVector(vector<string> & v) ;


void split( vector<string> & theStringVector,  /* Altered/returned value */
			const  string  & theString,
			const  string  & theDelimiter) ;

/*
 *	  get the strings inside s (strings are separated by a space)
 */
void get_strings(const string s, vector<string>& v) ;

	// convert an int into a string
string int_to_string(int value) ;


/**
 *  affiche les valeurs d'un vecteur
 */
template <typename T>
void displayVectorAsSet(const vector<T> &v)
{
	cout << "{ " ;

	for (unsigned int i = 0 ; i < v.size() ; i++)
	{
			cout << v.at(i) << " "  ;
	}

	cout << "}" ;
}






/**
 *  affiche les valeurs d'un vecteur
 */

template <typename T>
void displayVectorFlux(ostream& flux, string vectorName, const vector<T>& v)
{
	if(v.size() == 0)
	{
		flux << vectorName << " is empty " << endl ;
	}

	for (unsigned int i = 0 ; i < v.size() ; i++)
	{
			flux << vectorName << "[" << i << "] : " << v.at(i) << endl ;
	}

	flux << endl ;
}



/**
 *  affiche les valeurs d'un vecteur
 */
template <typename T>
void displayVectorVectorAsSet(const vector<vector<T> > &v)
{
	cout << "{" ;

	for (unsigned int i = 0 ; i < v.size() ; i++)
	{
			displayVectorAsSet(v.at(i)) ;
	}

	cout << "}" << endl ;
}

/**
 *  affiche les valeurs d'un vecteur
 */
template <typename T>
void displayVector(string vectorName, const vector<T> &v)
{
	if(v.size() == 0)
	{
		cout << vectorName << " is empty " << endl ;
	}

	for (unsigned int i = 0 ; i < v.size() ; i++)
	{
			cout << vectorName << "[" << i << "] : " << v.at(i) << endl ;
	}

	cout << endl ;
}


/**
 *  affiche les valeurs d'un vecteur de vecteur
 */
template <typename T>
void displayVectorVector(string vectorName, const vector< vector<T> > &v)
{
	if(v.size() == 0)
	{
			cout << vectorName << " is empty " << endl ;
	}

	for (unsigned int i = 0 ; i < v.size() ; i++)
	{
			displayVector(vectorName + "[" + int_to_string(i) + "]", v.at(i)) ;
	}
	cout << endl ;
}


template <typename T1, typename T2>
void displayPair(pair<T1,T2> p)
{
	cout << "<" << p.first << ", " << p.second << ">" ;
}



/**
 *  affiche les valeurs d'un set
 */
template <typename T1, typename T2>
void displaySetPair(string setName, const set<pair<T1,T2> >& s)
{

	typename set<pair<T1,T2> >::iterator it ;
	typename set<pair<T1,T2> >::iterator it_end = s.end() ;

	cout << setName << "  = {" ;

	for (it = s.begin() ; it != it_end ; it++)
	{
		if (it != s.begin())
				cout << ", " ;

		displayPair(*it)   ;
	}

	cout << "}" << endl ;
}


/**
 *  affiche les valeurs d'un ensemble non ordonne
 */
template <typename T>
void displayUnorderedSet(string name, unordered_set<T> &s)
{
	typename unordered_set<T>::iterator it ;
	typename unordered_set<T>::iterator it_end = s.end() ;

		cout << name << "  = {" ;

		for (it = s.begin() ; it != it_end ; it++)
		{
			if (it != s.begin())
					cout << ", " ;

			cout << *it   ;
		}

		cout << "}" << endl ;
}


/**
 *  affiche les valeurs d'un set
 */
template <typename T>
void displaySet(string setName, set<T>& s)
{
	typename set<T>::iterator it ;
	typename set<T>::iterator it_end = s.end() ;

	cout << setName << "  = {" ;

	for (it = s.begin() ; it != it_end ; it++)
	{
		if (it != s.begin())
				cout << ", " ;

		cout << *it   ;
	}

	cout << "}" << endl ;
}


/**
 *  affiche les valeurs d'un vecteur de sets
 */
template <typename T>
void displayVectorSet(string vectorName, const vector< set<T> > &v)
{
	if(v.size() == 0)
	{
			cout << vectorName << " is empty " << endl ;
	}

	for (unsigned int i = 0 ; i < v.size() ; i++)
	{
			displaySet3(vectorName + "[" + int_to_string(i) + "]", v.at(i)) ;
	}
	cout << endl ;
}

template <typename T1, typename T2>
void displayMap(string mapName, map<T1, T2>& m)
{
	cout << mapName << " : " << endl ;

	if(m.size() == 0)
	{
				cout << mapName << " is empty " << endl ;
	}

	typename map<T1, T2>::iterator it = m.begin() ;

	for (it = m.begin() ; it != m.end() ; it++)
	{
		cout << "(" << it->first << "," << it->second << ") "  << endl ;
	}
	cout << endl ;
}


template <typename T1, typename T2>
void displayMapSet(string mapName, map<T1,set<T2> >& m)
{
	if(m.size() == 0)
	{
			cout << mapName << " is empty " << endl ;
	}

	typename map<T1, set<T2> >::iterator it = m.begin() ;

	for (it = m.begin() ; it != m.end() ; it++)
	{
			cout << (*it).first ;

			displaySet("", (*it).second) ;
	}
	cout << endl ;
}


template <typename T>
bool is_sorted(const std::vector<T> &v)
{
  if(v.size() < 2)
    return true; 

  for(typename std::vector<T>::const_iterator it = ++v.begin(); it != v.end(); ++it)
  {
    if(*it < *(it-1))
       return false; 
  }
  return true; 
}


// ------------------------------ Operateurs ensemblises ------------------------

	// out est l'union de t1 et t2
template <typename T>
void setUnion(set<T>* out, const set<T> &t1, const set<T> &t2)
{
	set_union(
	             t1.begin(), t1.end(),
				 t2.begin(), t2.end(),
	             inserter(*out, out->begin())
			 ) ;
}


	// out est l'intersection de t1 et t2
template <typename T>
void setIntersection(set<T> *out, const set<T> &t1, const set<T> &t2)
{
  set_intersection (
		             t1.begin(), t1.end(),
					 t2.begin(), t2.end(),
		             inserter(*out,out->begin())
				    ) ;
}


#endif
