/*
** utils.c
** 
** Made by (Benjamin Negrevergne)
** Email   [firstname].[name]@imag.fr
** 
** Started on  Thu Sep  2 13:15:21 2010 Benjamin Negrevergne
*/

#include <iostream>
#include <fstream>
#include <algorithm>
#include <sstream>
#include <iterator>
#include "utils_divers.hpp"

using namespace std; 



/*
 *	  get the strings inside s (strings are separated by delimiter)
 */
void get_strings(const string s, char delimiter, vector<string>& v)
{
						// construct a stream from the string
	  stringstream strstr(s);
	  string line ;

	  // while(it != istream_iterator<string>())
      while(getline(strstr, line, delimiter))
	  {
		  v.push_back(line) ;
	  }
}


/*
 *	  get the ints inside s (ints are separated by delimiter)
 */
void get_ints(const string s, char delimiter, vector<int>& v)
{
						// construct a stream from the string
	  stringstream strstr(s);
	  string line ;

      int value ;

	  // while(it != istream_iterator<string>())
      while(getline(strstr, line, delimiter))
	  {
		  value = stoi(line) ;
		  v.push_back(value) ;
	  }
}


/*
 *	  get the ints inside s (ints are separated by delimiter)
 *	  put the values in a set
 */
void get_ints(const string s, char delimiter, set<int>& v)
{
						// construct a stream from the string
	  stringstream strstr(s);
	  string line ;

      int value ;

	  // while(it != istream_iterator<string>())
      while(getline(strstr, line, delimiter))
	  {
		  value = stoi(line) ;
		  v.insert(value) ;
	  }
}


/*
 *	  get the strings inside s (strings are separated by delimiter)
 *	  put the strings in a set
 */
void get_strings(const string s, char delimiter, set<string>& v)
{
						// construct a stream from the string
	  stringstream strstr(s);
	  string line ;

      while(getline(strstr, line, delimiter))
	  {
		  v.insert(line) ;
	  }
}


	// extrait de line le motifs entouré d'accolades
	// {motif}
void extrait_motif(string& line, int debut, string& motif, int& fin)
{
	// cerr << line << endl ;
	fin = line.find('}', debut);					// recherche fin du motif
	int taille_motif = fin - debut + 1 ;
	// cerr << "!" << line[debut] << endl ;
	motif = line.substr(debut, taille_motif) ;
	// cerr << motif << endl ;
}

	// extrait les motifs presents dans une liste de motifs
	// {motif1{...}, motif2{...}, ...}
void extrait_motifs(string& line, int debut, vector<string>& motifs, int& fin)
{

}


	// display nTabs
void display_spaces(int n)
{
	for (int i=0 ; i < n ; i++)
	{
		cout << " " ;
	}
}


/**
 *  delete the spaces in each string inside v
 */
void trimStringVector(vector<string> & v)
{
	for (unsigned int i = 0 ; i < v.size() ; i++)
	{
		string::iterator end_pos = remove(v[i].begin(), v[i].end(), ' ');
		v[i].erase(end_pos, v[i].end());
	}
}



void split( vector<string> & theStringVector,  /* Altered/returned value */
			const  string  & theString,
			const  string  & theDelimiter)
{

    size_t  start = 0 ;
    size_t  end = 0  ;

    // cout << "string =" << theString    << "xx" << endl ;
    // cout << "del    =" << theDelimiter << "xx" << endl ;

    do
    {
    	 end = theString.find(theDelimiter, start);
    	 // cout << "end=" << end << endl ;

    	 string s ;

    	 if (end == string::npos)
    	 {
    		 	 	 // dernier token
			s = theString.substr(start, string::npos) ;
    	 }
    	 else
    	 {
    		 	 	 // reste au moins 2 tokens
    		 	 	 // dernier token
			s = theString.substr (start, end - start) ;

			start = end + theDelimiter.size() ;
			// cout << "start = " << start << endl ;
    	 }

    	 // cout << "s =" << s << "xx" << endl ;
    	 theStringVector.push_back(s);
    }
    while (end != string::npos) ;
}


/*
 *	  get the strings inside s (strings are separated by a space)
 */
void get_strings(const string s, vector<string>& v)
{
						// construct a stream from the string
	  stringstream strstr(s);
	  istream_iterator<string> it(strstr);

	  while(it != istream_iterator<string>())
	  {
		  v.push_back(*it) ;
		  it++ ;
	  }
}


	// convert an int into a string
string int_to_string(int value)
{
 string s;
 stringstream out;
 out << value ;
 return out.str();
}
